#include "AudioHandler.h"

AudioHandler* AudioHandler::m_Instance = 0;

AudioHandler* AudioHandler::getInstance()
{
	if (m_Instance == 0)
	{
		m_Instance = new AudioHandler();
	}

	return m_Instance;
}

AudioHandler::AudioHandler() {

	m_Audio = CocosDenshion::SimpleAudioEngine::getInstance();

}

void AudioHandler::playEffect(std::string name) {

	m_Audio->playEffect(m_Effect.find(name)->second.c_str());

}

void AudioHandler::playBackgroundMusic(std::string name){

	m_Audio->playBackgroundMusic(m_Music.find(name)->second.c_str());

}

void AudioHandler::addEffect(std::string filepath, std::string name) {

	m_Audio->preloadEffect(filepath.c_str());

	m_Effect.insert(std::pair<std::string, std::string>(name, filepath));

}

void AudioHandler::addMusic(std::string filepath, std::string name) {

	m_Audio->preloadBackgroundMusic(filepath.c_str());

	m_Music.insert(std::pair<std::string, std::string>(name, filepath));

}