#ifndef AUDIOHANDLER_H
#define AUDIOHANDLER_H

#include "cocos2d.h"
#include "SimpleAudioEngine.h"

class AudioHandler{

	public:

		AudioHandler* getInstance();

		void playEffect(std::string name);
		void playBackgroundMusic(std::string name);

		void addEffect(std::string filepath, std::string name);
		void addMusic(std::string filepath, std::string name);

	private:

		AudioHandler();
		~AudioHandler() {};

		static AudioHandler* m_Instance;

		CocosDenshion::SimpleAudioEngine* m_Audio;

		std::map<std::string, std::string> m_Effect;
		std::map<std::string, std::string> m_Music;

};
#endif // DEFINE - AUDIOHANDLER_H