// THIS CLASS IS A TEST COCOS2DX SCENE CLASS FOR DEMONSTRATING THE API

#ifndef GADDBOXSCENE_H
#define GADDBOXSCENE_H

#define DTR_RATIO 0.0174532925199432957f
#define RTD_RATIO 57.295779513082320876f

#include "cocos2d.h"
#include "GaddBox.h"
#include "MyBullet.h"
#include "GameObject.h"
#include "SessionData.h"
#include "Utils.h"

class GaddBoxScene : public cocos2d::Scene {

	public:

		static cocos2d::Scene* createScene();

		CREATE_FUNC(GaddBoxScene);

		bool init();

		void update(float delta) override;

		virtual bool onTouchBegan(cocos2d::Touch* touch, cocos2d::Event* event);
		virtual void onTouchMoved(cocos2d::Touch* touch, cocos2d::Event* event);
		virtual void onTouchEnded(cocos2d::Touch* touch, cocos2d::Event* event);
		virtual void onTouchCancelled(cocos2d::Touch* touch, cocos2d::Event* event);

		void initTouch();

	private:

		GaddBox* m_Gaddbox;
		SessionData* m_SessionData;
		Utils* m_Utils;

		cocos2d::Size m_WindowSize;
		cocos2d::Size m_VisibleSize;

		std::vector<int> m_Players;
		std::map<int, GameObject*> m_GaddBoxObjects;

		std::map<int, GameObject*> m_Enemies;
		std::map<int, GameObject*>::iterator m_EnemiesIter;

		cocos2d::Sprite* m_Base;

		cocos2d::Vec2 m_Spawn;
		cocos2d::Vec2 m_TouchBegin;
		cocos2d::Vec2 m_TouchMove;

		cocos2d::DrawNode* m_DrawNode;

};

#endif // GADDBOXSCENE_H