#ifndef SessionData_H
#define SessionData_H

#include "cocos2d.h"
#include "Box2D\Box2D.h"

class SessionData {

	public:

		SessionData* getInstance();

		void setScale(float scale) { m_Scale = scale; };
		float getScale() { return m_Scale; };

		void died() { m_Lives -= 1; };
		int getLives() { return m_Lives; };
		void setLives(int lives) {m_Lives = lives; };

		void setDifficulty(int difficulty) { m_Difficulty = difficulty; };
		int getDifficulty() { return m_Difficulty; };

		void setMobile(bool mobile) { m_Mobile = mobile; };
		bool getMobile() { return m_Mobile; };

		void addArtifact() { m_Artifacts++; };
		int getArtifacts() { return m_Artifacts; };

		void setTime(float time) { m_Remaining = time; };
		float getTime() { return m_Remaining; };

		void setGameOver(bool gameover) { m_GameOver = gameover; };
		bool getGameOver() { return m_GameOver; };

		int getKills() { return m_Kills; };
		void kill() { m_Kills += 1; };

		std::string getHardness() { return m_Hardness; };
		void setHardness(std::string hardness) { m_Hardness = hardness; };

		void setSceneSize(float size) { m_SceneWidth = size; };
		int getSceneSize() { return m_SceneWidth; };

		void setB2World(b2World* B2World) { m_B2World = B2World; };
		b2World* getB2World() { return m_B2World; };

		void setMainLayer(cocos2d::Layer* layer) { m_MainLayer = layer; };
		cocos2d::Layer* getMainLayer() { return m_MainLayer; };

		void setDrawNode(cocos2d::DrawNode* drawNode) { m_DrawNode = drawNode; };
		cocos2d::DrawNode* getDrawNode() { return m_DrawNode; };

		float getWinWidth() { return m_WinWidth; };
		float getWinHeight() { return m_WinHeight; };

		void setWinWidth(float winWidth) { m_WinWidth = winWidth; };
		void setWinHeight(float winHeight) { m_WinHeight = winHeight; };

		float getSpace() { return m_Space; }
		void setSpace(float space) { m_Space = space; }

		float getDistance() { return m_Distance; }
		void setDistance(float distance) { m_Distance = distance; }

	private:

		SessionData();
		~SessionData() {};

		static SessionData* m_Instance;

		b2World* m_B2World;
		cocos2d::Layer* m_MainLayer;
		cocos2d::DrawNode* m_DrawNode;

		std::string m_Hardness;

		float m_Scale;
		float m_Time;
		float m_Remaining;
		float m_WinWidth;
		float m_WinHeight;
		float m_Space;
		float m_Distance;

		int m_Lives;
		int m_Difficulty;
		int m_Artifacts;
		int m_Kills;
		int m_SceneWidth;

		bool m_Mobile;
		bool m_GameOver;

};
#endif // DEFINE - SessionData_H