#include "Utils.h"

Utils* Utils::m_Instance = 0;

// RETURN POINTER SINGLETON
Utils* Utils::getInstance() {

	if (m_Instance == 0) {

		m_Instance = new Utils();

	}

	return m_Instance;
}

// CHECK IF POINT IS INSIDE CIRCLE
bool Utils::inCircle(cocos2d::Vec2 point, cocos2d::Vec2 center, float radius) {

	float distance = sqrt(pow(center.x - point.x, 2) + pow(center.y - point.y, 2));

	return distance <= radius;

}

// RETURN RANDOM FLOATING NUMBER BETWEEN TWO VALUES - CASTED
float Utils::randomFloat(float min, float max){

    if(min < 0){



    }

	int rand = std::rand() % int(max - min);

	return min + float(rand);

}

// CHECK IF POSITION IS OUTSIDE SESSION DATA BOUNDS
bool Utils::outsideBounds(cocos2d::Vec2 position){

	float scenewidth = m_SessionData->getInstance()->getSceneSize();

	if(position.x < (-scenewidth - 1000)){ 
		return true; 
	}
	else if(position.x > (scenewidth + 1000)){ 
		return true; 
	}
	else if(position.y < (-scenewidth - 1000)){ 
		return true; 
	}
	else if(position.y > (scenewidth + 1000)){ 
		return true; 
	}

	return false;

}

// DISTANCE BETWEEN TWO POINTS
float Utils::distance(cocos2d::Vec2 position, cocos2d::Vec2 target) {

	float x_diff = position.x - target.x;
	float y_diff = position.y - target.y;

	float diff = std::sqrt(x_diff * x_diff + y_diff * y_diff);

	return diff;

}

