#ifndef GADDBOX_UTILS_H
#define GADDBOX_UTILS_H

#include "cocos2d.h"
#include "SessionData.h"
#include <stdlib.h>

template <typename T>
std::string to_string(T value)
{
	std::ostringstream os;
	os << value;
	return os.str();
};

class Utils {

	public:

	Utils* getInstance();

		std::string to_StringF(float value) { return to_string(value); };
		std::string to_StringI(int value) { return to_string(value); };

		bool inCircle(cocos2d::Vec2 point, cocos2d::Vec2 center, float radius);

		float randomFloat(float min, float max);

		bool outsideBounds(cocos2d::Vec2 position);

		void initCount() { m_Objects = 0 ; };
		void increment() { m_Objects++; };
		int getCount() { return m_Objects; };

		float distance(cocos2d::Vec2 position, cocos2d::Vec2 target);

	private:

		Utils() {};
		~Utils() {};

		static Utils* m_Instance;

		SessionData* m_SessionData;

		int m_Objects;

};
#endif // DEFINE - GADDBOX_UTILS_H